###########################################################################
#
# Makefile -- Makefile for indexers used by Greenstone
#
# A component of the Greenstone digital library software
# from the New Zealand Digital Library Project at the
# University of Waikato, New Zealand.
#
# Copyright (C) 2007 New Zealand Digital Library Project
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################


# INDEXERDIRS contains the packages that we want to make and install.  It
# is assumed that each package will have at least four rules: all, install,
# clean, and distclean.

ENABLE_ACCENTFOLD=@ENABLE_ACCENTFOLD@
ifeq ($(ENABLE_ACCENTFOLD), 1)
UNAC=packages/unac
else
UNAC=
endif

ENABLE_MG=@ENABLE_MG@
ifeq ($(ENABLE_MG), 1)
MG=mg
else
MG=
endif

ENABLE_MGPP=@ENABLE_MGPP@
ifeq ($(ENABLE_MGPP), 1)
MGPP=mgpp
else
MGPP=
endif

ENABLE_LUCENE=@ENABLE_LUCENE@
ifeq ($(ENABLE_LUCENE), 1)
LUCENE=lucene-gs
else
LUCENE=
endif

JAVAC=@JAVAC@

INDEXERDIRS = $(UNAC) $(MG) $(MGPP) $(LUCENE)

all: with-jni

clean:
	for odir in $(INDEXERDIRS); do \
	  if test -d $$odir; then \
	    echo making $@ in $$odir; \
	    (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
	  fi; \
        done

with-jni:
	for odir in $(INDEXERDIRS); do \
	  if test -d $$odir; then \
	    echo making all in $$odir; \
	    (cd $$odir && $(MAKE) $(MDEFINES) all) || exit 1; \
	  fi; \
        done

install-with-jni:
	for odir in $(INDEXERDIRS); do \
	  if test -d $$odir; then \
	    echo making install in $$odir; \
	    (cd $$odir && $(MAKE) $(MDEFINES) install) || exit 1; \
	  fi; \
        done

# make everything except jni stuff
without-jni:
	for odir in $(UNAC) $(LUCENE); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) all) || exit 1; \
        done
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) nojava) || exit 1; \
        done

install-without-jni:
	for odir in $(UNAC) $(LUCENE); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) install) || exit 1; \
        done
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) install-nojava) || exit 1; \
        done

nojava:
	for odir in $(UNAC); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) all) || exit 1; \
        done
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
        done

install-nojava:
	for odir in $(UNAC); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) install) || exit 1; \
        done
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
        done

javaonly:
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
        done
	for odir in $(LUCENE); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) all) || exit 1; \
        done

install-javaonly:
	for odir in $(MG) $(MGPP); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
        done
	for odir in $(LUCENE); do \
          echo making $@ in $$odir; \
          (cd $$odir && $(MAKE) $(MDEFINES) install) || exit 1; \
        done

distclean:
	for odir in $(INDEXERDIRS); do \
	  if test -d $$odir; then \
	    echo making $@ in $$odir; \
	    (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
	  fi; \
        done
	rm -f Makefile config.status config.log